﻿var Mapzania = (function (ns) {

    //---------------------------------------------------------

    ns.Constants = ns.Constants || {};
    ns.Constants.QUERYENGINE_LAYERSOURCE_NAME = "MAPZANIA_QUERYENGINE_LAYERSOURCE";
    ns.QueryEngine = QueryEngine;
    return ns;

    //---------------------------------------------------------

    function QueryEngine(options) {

        var api = new ns.Factory(null, null, options).getApi();

        //---------------------------------------------------------

        this.usingFeatureCollection = function (featureCollection) {

            var filters = [{
                type: "AddFeatureCollection",
                features: featureCollection
            }];

            sourceKey = ns.Constants.QUERYENGINE_LAYERSOURCE_NAME;

            return new Query(sourceKey, filters);
        }

        this.usingLayerSource = function (sourceKey) {
            return new Query(sourceKey);
        }

        this.usingMapLayer = function (map, layerKey, options) {

            var defaults = {
                useState: true,
                useFilters: true
            };

            var settings = Object.assign(defaults, options);

            var layer = map.getLayer(layerKey);
            var sourceKey = layer.sourceKey;

            var filters = [];

            if (settings.useFilters)
                Array.prototype.push.apply(filters, map.getFilters(layerKey));

            if (settings.useState)
                Array.prototype.push.apply(filters, map.getStateFilters(layerKey));

            return new Query(sourceKey, filters);
        }

        //---------------------------------------------------------

        function Query (sourceKey, filters) {
            if (!filters)
                filters = [];

            this.filterByText = function (statement, passthru) {
                var filter = ns.Filters.filterByText(statement, passthru);
                filters.push(filter);
                return this;
            }

            this.filterByBoundingBox = function (bbox) {
                var filter = ns.Filters.filterByBoundingBox(bbox);
                filters.push(filter);
                return this;
            }

            this.filterByNearest = function (point, take, includeDistance) {
                var filter = ns.Filters.filterByNearest(point, take, includeDistance);
                filters.push(filter);
                return this;
            }

            this.filterByFeatureCollection = function (features, operation) {
                var filter = ns.Filters.filterByFeatureCollection(features, operation);
                filters.push(filter);
                return this;
            }

            this.filterByLayer = function (layerKey, layerFilters, operation) {
                var filter = ns.Filters.filterByLayer(layerKey, layerFilters, operation);
                filters.push(filter);
                return this;
            }

            this.clipByFeatureCollection = function (featureCollection) {
                var filter = ns.Filters.clipByFeatureCollection(featureCollection);
                filters.push(filter);
                return this;
            }

            this.changeProperties = function (properties) {
                var filter = ns.Filters.changeProperties(properties);
                filters.push(filter);
                return this;
            }

            this.convertToCentroids = function () {
                var filter = ns.Filters.convertToCentroids();
                filters.push(filter);
                return this;
            }

            this.bufferGeometry = function (factor, side, joins, ends, mitreLimit, srid) {
                var filter = ns.Filters.bufferGeometry(factor, side, joins, ends, mitreLimit, srid);
                filters.push(filter);
                return this;
            }

            this.apply = function () {

                return new Promise(function (resolve, reject) {

                    api.getFeatures(sourceKey, filters)
                        .success(function (data, xhr) {
                            resolve(data);
                        })
                });

                return res;
            }
        }
    }

})(Mapzania || {})
