﻿/// <reference path="../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    ns.Schema = Schema;
    return ns;

    //---------------------------------------------------------

    function Schema(json) {

        ns.Log.debug("Object created.", "Schema", json);

        //-----------------------------------------------------

        this.getInitialBoundingBox = function () {
            var ext = json.startExtent;
            return [ext.minX, ext.minY, ext.maxX, ext.maxY];
        }

        this.getLayers = function () {
            return json.layers;
        }

        this.getLayer = function (layerKey) {
            var lyr;
            json.layers.forEach(function (item) {
                if (item.key == layerKey)
                    lyr = item;
            })

            if (!lyr)
                ns.Util.LogAndThrow("No layer exists for key=" + layerKey, "Schema.getLayer()");

            return lyr;
        }

        this.getThemes = function (layerKey) {

            var lyr = this.getLayer(layerKey);
            var themes = lyr.themes;

            if (!themes)
                ns.Util.LogAndThrow("No themes exist for layerKey=" + layerKey, "Schema.getThemes()");

            return themes;
        }
    }

})(Mapzania || {});