﻿/// <reference path="../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    var GJ = ns.GeoJson = ns.GeoJson || {};
    GJ.buffer = buffer;

    buffer.implemented = {
        BoundingBox: doBoundingBox
    };

    return ns;

    //---------------------------------------------------------

    function buffer(geometry, ratio) {

        var type = GJ.getType(geometry);
        var func = buffer.implemented[type];

        if (!func)
            GJ.Exceptions.notImplemented(type, "buffer");

        return func(geometry, ratio);
    }

    //---------------------------------------------------------

    function doBoundingBox(geometry, ratio) {
        var centroid = GJ.getCentroid(geometry);

        var x = centroid.coordinates[0];
        var y = centroid.coordinates[1];

        var width = Math.abs(geometry[0] - geometry[2]);
        var height = Math.abs(geometry[1] - geometry[3]);

        var deltaX = (ratio * width) / 2;
        var deltaY = (ratio * height) / 2;

        return [x - deltaX, y - deltaY, x + deltaX, y + deltaY];
    }

})(Mapzania || {});