﻿/// <reference path="../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    var GJ = ns.GeoJson = ns.GeoJson || {};
    GJ.explode = explode;

    explode.implemented = {
        Point: toPoint,
        MultiPoint: toPoints,
        LineString: toPoints,
        MultiLineString: toLines,
        Polygon: toLines,
        MultiPolygon: toPolygons
    };

    return ns;

    //---------------------------------------------------------

    function explode(geometry) {

        var type = GJ.getType(geometry);
        var func = explode.implemented[type];

        if (!func)
            GJ.Exceptions.notImplemented(type, "explode");

        return func(geometry);
    }

    //---------------------------------------------------------

    function toPoint(geometry) {
        return [ns.Util.assign({}, geometry)];
    }

    function toPoints(geometry) {
        return geometry.coordinates.map(m => GJ.createPoint(m));
    }

    function toLines(geometry) {
        return geometry.coordinates.map(m => GJ.createLineString(m));
    }

    function toPolygons(geometry) {
        return geometry.coordinates.map(m => GJ.createPolygon(m));
    }

})(Mapzania || {});