﻿/// <reference path="../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    var GJ = ns.GeoJson = ns.GeoJson || {};
    GJ.getLength = getLength;

    getLength.implemented = {
        BoundingBox: zero,
        Point: zero,
        MultiPoint: zero,
        LineString: doLineString,
        MultiLineString: doMultiLineString,
        Polygon: zero,
        MultiPolygon: zero,
        GeometryCollection: doGeometryCollection
    };

    return ns;

    //---------------------------------------------------------

    function getLength(geometry) {

        var type = GJ.getType(geometry);
        var func = getLength.implemented[type];

        if (!func)
            GJ.Exceptions.notImplemented(type, "getLength");

        return func(geometry);
    }

    //---------------------------------------------------------

    function zero(geometry) {
        return 0;
    }

    function doLineString(geometry) {

        var coords = geometry.coordinates;

        if (coords.length < 2)
            return 0;

        var result = 0;

        for (var i = 1; i < coords.length; i++)

            result += ns.GeoJson.Math.distance(
                coords[i - 1][0],
                coords[i - 1][1],
                coords[i][0],
                coords[i][1]
                );

        return result;
    }

    function doMultiLineString(geometry) {
        return geometry.coordinates.reduce(function (total, coords) {
            return total + doLineString({ coordinates: coords });
        }, 0);
    }

    function doGeometryCollection(geometry) {
        for (i = 0; i < geometry.geometries.length; i++) {
            length += getLength(geometry.geometries[i]);
        }
        return length;
    }

})(Mapzania || {});