﻿/// <reference path="../../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    ns.RasterLayer = RasterLayer;
    return ns;

    //---------------------------------------------------------

    function RasterLayer(layerJSON, sourceJSON) {

        var isVisible = layerJSON.visible;

        this.isVisible = function () {
            return isVisible;
        }

        this.show = function () {
            isVisible = true;
        }

        this.hide = function () {
            isVisible = false;
        }

        this.getType = function () {
            return "RasterLayer";
        }

        this.getKey = function () {
            return layerJSON.key;
        }

        this.getUrl = function () {
            return sourceJSON.url;
        }

        this.isGreyScale = function () {
            return layerJSON.greyScale;
        }

        this.getAttribution = function () {
            return sourceJSON.attribution;
        }

        this.toJSON = function () {
            return {
                key: layerJSON.key,
                name: layerJSON.name,
                sourceKey: layerJSON.sourceKey,
                ordinal: layerJSON.ordinal,
                //url: sourceJSON.googleTileUrl,
                visible: isVisible
            };
        }
    }

})(Mapzania || {})
