﻿/// <reference path="../../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    ns.Leaflet = ns.Leaflet || {};
    ns.Leaflet.LabelLayer = extendClass();
    return ns;

    //---------------------------------------------------------

    function extendClass() {
        return L.FeatureGroup.extend({

            initialize: function (options) {
                L.Util.setOptions(this, options);
                this._layers = {};
            },

            addLabels: function (featureCollection) {

                var me = this;

                featureCollection.features.forEach(function (ftr) {

                    var coords = ftr.geometry.coordinates;

                    var latlng = new L.LatLng(coords[1], coords[0], coords[2]);

                    //---TEMP----
                    //var layer = L.circleMarker(latlng, {
                    //    radius: 2,
                    //    stroke: false,
                    //    fillOpacity: 1,
                    //    fillColor: "#FF0000"
                    //});
                    //me.addLayer(layer);
                    //-----------

                    var style = ns.Leaflet.SymbolConverter.toCss(ftr.properties["symbol"]);
                    var text = ftr.properties["text"];

                    var measure = me._measureText(text, style);

                    var layer = new ns.Leaflet.Label({
                        offset: [-measure.width / 2, -measure.height / 2],
                        position: latlng,
                        text: text,
                        style: style,
                        rotation: -ftr.properties["rotation"]
                    });

                    me.addLayer(layer);
                });

                return this;
            },

            _measureText: function (text, style) {

                var el;

                if (!this._el) {
                    el = this._el = document.createElement("div");
                    document.body.appendChild(el);
                }
                else
                    el = this._el;

                el.setAttribute("style", style);
                el.style.position = "absolute";
                el.style.left = "-1000px";
                el.style.top = "-1000px";
                el.innerHTML = text;

                return { height: el.offsetHeight, width: el.offsetWidth };
            }
        });
    }

})(Mapzania || {});