﻿/// <reference path="../../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    ns.Leaflet = ns.Leaflet || {};
    ns.Leaflet.Label = extendClass();
    return ns;

    //---------------------------------------------------------

    function extendClass() {
        return L.DivOverlay.extend({

            initialize: function (options) {
                L.setOptions(this, options);
            },

            _initLayout: function () {

                var className = "leaflet-zoom-" + (this._zoomAnimated ? "animated" : "hide");
                var node = this._contentNode = this._container = L.DomUtil.create('div', className);

                var o = this.options;

                node.setAttribute("style", o.style);

                //node.style["background-color"] = "white";

                node.innerHTML = o.text;

                this.setLatLng(o.position);
            },

            // ---------- Required Overrides----------------
            _updateLayout: function () { },
            _adjustPan: function () { },
            _animateZoom: function (e) {
                var pos = this._map._latLngToNewLayerPoint(this._latlng, e.zoom, e.center);
                this._setPosition(pos);
            },

            _updatePosition: function () {
                var pos = this._map.latLngToLayerPoint(this._latlng);
                this._setPosition(pos);
            },

            _setPosition: function (pos) {
                var map = this._map;
                var container = this._container;
                var offset = L.point(this.options.offset);

                pos = pos.add(offset);

                //chrome blurriness fix
                pos.x = Math.round(pos.x);
                pos.y = Math.round(pos.y);

                L.DomUtil.setPosition(container, pos);

                //var origin = node.style["transform-origin"]
                container.style["transform-origin"] = "center";
                container.style[L.DomUtil.TRANSFORM] += (" rotate(" + this.options.rotation + "rad)");
            },

        });
    }

})(Mapzania || {});