﻿/// <reference path="../../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    ns.Leaflet = ns.Leaflet || {};
    ns.Leaflet.Toolbar = extendClass();
    return ns;

    //---------------------------------------------------------

    function extendClass() {
        return L.Control.extend({

            options: {
                position: 'topleft'
            },

            initialize: function (buttons, options) {

                if (options) {
                    L.Util.setOptions(this, options);
                }

                this._bar = this.container = L.DomUtil.create('div', 'leaflet-bar');

                if (!buttons)
                    buttons = [];

                for (var i = 0; i < buttons.length; i++) {
                    addButton(buttons[i]);
                }
            },

            onAdd: function (map) {
                return this.container;
            },

            addButton: function (button) {
                var link = L.DomUtil.create("a", "leaflet-control-zoom-in", this._bar);

                link.href = '#';
                link.innerHTML = button.html;
                link.title = button.title;

                link.setAttribute('role', 'button');
                link.setAttribute('aria-label', button.title);
                link.setAttribute("style", button.style);

                L.DomEvent.disableClickPropagation(link);
                L.DomEvent.on(link, 'click', L.DomEvent.stop);
                if (button.fn)
                    L.DomEvent.on(link, 'click', button.fn, this);
                L.DomEvent.on(link, 'click', this._refocusOnMap, this);

                return link;
            }
        });
    }

})(Mapzania || {});