﻿/// <reference path="../../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    ns.RangeTheme = RangeTheme;
    return ns;

    //---------------------------------------------------------

    function RangeTheme(json) {

        //TODO: Normalisation

        var symbols = {};

        ns.Log.debug("Object created.", "RangeTheme");

        this.getType = function () {
            return "RangeTheme";
        }

        this.getMinZoom = function () {
            return json.minZoom;
        };

        this.getMaxZoom = function () {
            return json.maxZoom;
        };

        this.getSymbol = function (feature) {

            var val = getThemeValue(feature);

            if (val && val.symbol) 
                return val.symbol;
             else 
                return json.defaultSymbol;
        }

        this.getLabelText = function (feature) {

            var labeller = null;
            var themeValue = getThemeValue(feature);

            if (themeValue && themeValue.labeller) {
                labeller = themeValue.labeller;
            } else {
                labeller = json.labeller;
            }

            if (!labeller)
                return null;

            return feature.properties[labeller.field];
        }

        this.getLabelSymbol = function (feature) {

            var themeValue = getThemeValue(feature);

            if (themeValue && themeValue.labeller && themeValue.labeller.visible) {
                return themeValue.labeller;
            } else {
                if (!json.labeller || !json.labeller.visible)
                    return null;

                return json.labeller;
            }
        }

        this.getFilterText = function () {
            return json.filter;
        }

        //---------------------------------------------------------
        function getThemeValue(feature) {

            var featVal = feature.properties[json.field];

            for (var i = 0; i < json.values.length; i++) {
                var themeVal = json.values[i];

                if (themeVal.value) { // unique range
                    if (equalsIgnoreCase(featVal, themeVal.value)) {
                        return themeVal;
                    }
                } else { // range
                    if (featVal >= themeVal.min && featVal <= themeVal.max) {
                        return themeVal;
                    }
                }
            }

            return null;
        }

        var equalsIgnoreCase = function (s1, s2) {
            s1 = s1 ? String(s1) : "";
            s2 = s2 ? String(s2) : "";
            return s1.toUpperCase().trim() == s2.toUpperCase().trim();
        };
    }

})(Mapzania || {});