﻿/// <reference path="../../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    ns.StandardTheme = StandardTheme;
    return ns;

    //---------------------------------------------------------

    function StandardTheme(json) {

        _heal(json.labeller);

        ns.Log.debug("Object created.", "StandardTheme");

        this.getType = function () {
            return "StandardTheme";
        }

        this.getMinZoom = function () {
            return json.minZoom;
        };

        this.getMaxZoom = function () {
            return json.maxZoom;
        };

        this.getSymbol = function (feature) {
            return json.symbol;
        }

        this.getLabelText = function (feature) {

            var labeller = json.labeller;

            if (!labeller)
                return null;

            return feature.properties[labeller.field];
        }

        this.getLabelSymbol = function (feature) {

            if (json.labeller && json.labeller.visible)
                return json.labeller;

            return null;
        }

        this.getFilterText = function () {
            return json.filter;
        }

        function _heal(labeller) {

            var isNull = ns.Util.isNullOrUndefined;

            if (!isNull(labeller) && isNull(labeller.collisionDetection))
                labeller.collisionDetection = true;

        }
    }

})(Mapzania || {});