﻿/// <reference path="../mapzania.js"/>

var Mapzania = (function (ns) {

    //---------------------------------------------------------

    ns.Theme = Theme;
    return ns;

    //---------------------------------------------------------

    function Theme(json) {

        //TODO: Normalisation

        var symbols = {};

        ns.Log.debug("Object created.", "Theme");

        this.getType = function () {
            return "Theme";
        }

        this.getMinZoom = function () {
            return json.minZoom;
        };

        this.getMaxZoom = function () {
            return json.maxZoom;
        };

        this.getSymbol = function (feature) {

            var val = _getThemeValue(feature);

            if (val && val.symbol) 
                return val.symbol;
             else 
                return json.symbol;
        }

        this.getLabelText = function (feature) {

            var labeller = json.labeller;

            if (!labeller)
                return null;

            return feature.properties[labeller.field];
        }

        this.getLabelSymbol = function (feature) {
            if (json.labeller && json.labeller.visible)
                return json.labeller;

            return null;
        }

        this.getFilterText = function () {
            return json.filter;
        }

        //---------------------------------------------------------
        function _getThemeValue(feature) {

            var featVal = feature.properties[json.field];

            if (json.values) {

                for (var i = 0; i < json.values.length; i++) {
                    var themeVal = json.values[i];

                    if (themeVal.value) { // unique range
                        if (equalsIgnoreCase(featVal, themeVal.value)) {
                            return themeVal;
                        }
                    } else { // range
                        if (featVal >= themeVal.min && featVal <= themeVal.max) {
                            return themeVal;
                        }
                    }
                }
            }

            return null;
        }

        var equalsIgnoreCase = function (s1, s2) {
            s1 = s1 ? String(s1) : "";
            s2 = s2 ? String(s2) : "";
            return s1.toUpperCase().trim() == s2.toUpperCase().trim();
        };
    }

})(Mapzania || {});