﻿(function () {
    "use strict";

    angular
        .module("app")
        .controller("BoundsController", controller);

    controller.$inject = [
        "$scope",
        "ContextService",
        "Application",
        "CommandService"
    ];

    //-------------------------------------------------

    function controller(
        $scope,
        ContextService,
        Application,
        CommandService
    ) {

        var vm = this;

        this.copyFromMap = copyFromMap;

        init();

        //---------------------------------------------

        function init() {

            ContextService.on("context_set", (data) => {
                if (data.type == "Bounds") {
                    bind();
                }
            });

            bind();
        }

        function bind() {

            if (vm.model)
                unwatch(vm.model);

            var model = Application.model.getStartExtent();

            vm.model = Object.assign({}, model);

            watch(vm.model, onChanged);

            function onChanged(prop, action, newVal, oldVal) {
                CommandService.change(model, prop, newVal, oldVal);
                $scope.$apply();
            };
        }

        function copyFromMap() {
            CommandService.copyBoundsFromMap();
            bind();
        }
    }
})();