﻿(function () {
    "use strict";

    angular
        .module("app")
        .controller("RasterLayerController", controller);

    controller.$inject = [
        "$scope",
        "ContextService",
        "CommandService"
    ];

    //-------------------------------------------------

    function controller(
        $scope,
        ContextService,
        CommandService
    ) {

        var vm = this;

        init();

        //---------------------------------------------

        function init() {

            ContextService.on("context_set", (data) => {
                if (data.type == "RasterLayer") {
                    bind();
                }
            });

            bind();
        }

        function bind() {

            if (vm.model)
                unwatch(vm.model);

            var model = ContextService.getCurrent();

            vm.model = {
                visible: model.visible,
                key: model.key,
                name: model.name,
                opacity: model.opacity,
                greyScale: model.greyScale
            };

            watch(vm.model, onChanged);

            function onChanged(prop, action, newVal, oldVal) {

                if (prop == "visible") {
                    CommandService.changeLayerVisibility(model, newVal, oldVal);
                }
                else if (prop == "greyScale") {
                    CommandService.changeLayerGreyScale(model, newVal, oldVal);
                } else {
                    CommandService.change(model, prop, newVal, oldVal);
                }

                $scope.$apply();
            };
        }
    }

})();