﻿(function () {
	"use strict";

	angular
        .module("app")
        .service("ContextService", service);

	service.$inject = [];

	//-------------------------------------------------

	function service() {

        var svc = this;

        Mapzania.Util.eventify(svc, "ContextService");

        svc.context = [];

        svc.getContext = getContext;
        svc.setContext = setContext;
        svc.getCurrent = getCurrent;
        svc.getParent = getParent;
        svc.back = back;
        svc.isTop = isTop;

		//---------------------------------------------

        function getContext() {
            return svc.context;
        }

        function setContext(item, label, index) {

            if (Mapzania.Util.isUndefined(index))
                index = svc.context.length;

            svc.context.length = index + 1;
            svc.context[index] = { item: item, label: label };

            console.log("Context set....", getCurrent());

            svc.fire("context_set", getCurrent());
        }

        function getCurrent() {

            var len = svc.context.length;

            if (len < 1)
                return null;

            return svc.context[len - 1].item;
        }

        function getParent() {
            var len = svc.context.length;

            if (len < 2)
                return null;

            return svc.context[len - 2].item;
        }

        function back() {
            svc.context.length = svc.context.length - 1;

            console.log("Context set....", getCurrent());

            svc.fire("context_set", getCurrent());
        }

        function isTop() {
            return svc.context.length < 2;
        }

        //---------------------------------------------
	}

})();