﻿(function () {
    "use strict";

    angular
        .module("app")
        .controller("MapController", controller);

    controller.$inject = [
        "$scope",
        "ContextService",
        "Application",
        "CommandService"
    ];

    //-------------------------------------------------

    function controller(
        $scope,
        ContextService,
        Application,
        CommandService
    ) {

        var vm = this;

        init();

        //---------------------------------------------

        function init() {

            ContextService.on("context_set", (data) => {
                if (data.type == "Map") {
                    bind();
                }
            });

            bind();
        }

        function bind() {

            if (vm.model)
                unwatch(vm.model);

            var model = Application.model.getMap();

            vm.model = {
                key: model.key,
                name: model.name,
                backColor: model.backColor
            };

            watch(vm.model, onChanged);

            function onChanged(prop, action, newVal, oldVal) {

                if (prop == "backColor") {
                    CommandService.changeBackColor(newVal, oldVal);
                } else {
                    CommandService.change(model, prop, newVal, oldVal);
                }

                $scope.$apply();
            };
        }
    }

})();